﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals

	Public SecProviderID As String
	Public SecUserName As String
	Public SecPassword As String
	Public SecDeviceID As String
	Public FacilityCode As String,UserName As String,Password As String
	Public ProviderID As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	Try
		
	Catch
		Log("DoRegistration " & LastException)
		
	End Try
	
End Sub

Public Sub DoRegistration As ResumableSub
	
	Try
		SendRegistration
		
		Wait For SendRegistration_Complete
		
		Return Main.TestRet
	Catch
		Log("DoRegistration " & LastException)
		
		Return False
	End Try
	
End Sub


Private Sub SendRegistration
		
	
	Try
		Dim Params As String
		Dim response As String=""
		Dim jobClients As HttpJob
		Dim URL As String
		
		
		URL="http://www.example.com/DpRegistraion.aspx"
		
		Params="UserName="	& SecUserName &  "&DeviceID=" & SecDeviceID &  "&Password=" & SecPassword 
		
		
		jobClients.Initialize("", Me)
		
		jobClients.PostString(URL,Params)
				
		Wait For(jobClients)	JobDone(j As HttpJob)
		
		If J.Success=False Then
			
			ProgressDialogHide
			MsgboxAsync("Server unreachable, try again","HCMS")
			
			Wait For Msgbox_Result(Res As Int)
			
			If Res<>DialogResponse.POSITIVE Then
				Return
			End If
			
			Main.TestRet=False
			
			Return
			
		Else
			
			response =J.GetString
				
			wait for (ApplyResponse(response)) Complete (completed As Boolean)
			Main.TestRet = completed
			
			Log("SendRegistration " & Main.TestRet)
			
		End If
		
		J.release
		
		CallSubDelayed(Me,"SendRegistration_Complete")
		
	Catch
		ProgressDialogHide
		Log("SendRegistration " & LastException)
		
	End Try
	
	
End Sub
	
	
private Sub ApplyResponse(response As String) As ResumableSub
			
	Try
		Dim parser As JSONParser
		
		parser.Initialize(response)
		
		Dim root As Map=  parser.NextObject
				
	
		
		Try
		
		
			Dim RegKey As String
			Dim TransferResult As Int
			Dim ErrorStr As String, Result As String
			Dim su As StringUtils

			TransferResult=root.get("TransferResult")
			ErrorStr=root.Get("ErrorStr")
			Result=root.Get("Result")

		

			If TransferResult<>3 Then
				ProgressDialogHide
				MsgboxAsync("Registration has failed " & CRLF & "Error:" & ErrorStr & CRLF & "Result:" & Result & CRLF & " Check and try again","HCMS")
			
				Wait For Msgbox_Result(Res2 As Int)
			
				If Res2<>DialogResponse.POSITIVE Then
					Return False
				End If
					
			End If
		
			RegKey=root.get("RegKey")
			RegKey=su.DecodeUrl(RegKey,"UTF-8")
		
			'''Save RegKey into DB
		
			Return True
			
		Catch
			ProgressDialogHide
			Log("SaveRegistration " & LastException)
			Return False
		End Try
		
	Catch
		ProgressDialogHide
		Log("ApplyResponse " & LastException)
		
		Return False
	End Try
End Sub
		
Private Sub SaveRegistration(root As Map) As ResumableSub
			
	Try
		
		
		Dim RegKey As String
		Dim TransferResult As Int
		Dim ErrorStr As String, Result As String
		Dim su As StringUtils

		TransferResult=root.get("TransferResult")
		ErrorStr=root.Get("ErrorStr")
		Result=root.Get("Result")

		

		If TransferResult<>3 Then
			ProgressDialogHide
			MsgboxAsync("Registration has failed " & CRLF & "Error:" & ErrorStr & CRLF & "Result:" & Result & CRLF & " Check and try again","HCMS")
			
			Wait For Msgbox_Result(Res2 As Int)
			
			If Res2<>DialogResponse.POSITIVE Then
				Return False
			End If
					
		End If
		
		RegKey=root.get("RegKey")
		RegKey=su.DecodeUrl(RegKey,"UTF-8")
		
		'''Save RegKey into DB
		
		Return True
			
	Catch
		ProgressDialogHide
		Log("SaveRegistration " & LastException)
		Return False
	End Try
End Sub
	